package edu.mermet.tp8;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class Utilisateur {
	private String nom, chemin;
	private Properties properties;

	
	public Utilisateur() {
		this.nom = "login";
		chemin = "src/ressources/.ihm/login.xml";
		properties = new Properties();
		try {
			properties.loadFromXML(new FileInputStream(chemin));
		} catch (IOException e) {
			System.err.println("le fichier login.xml n'existe pas");
			this.enregistrer();
		}
	}


	
	public Utilisateur(String nom) {
		this.nom = nom;
		properties = new Properties();
		chemin = "src/ressources/.ihm/" + nom + ".xml";
		try {
			properties.loadFromXML(new FileInputStream(chemin));
		} catch (IOException e) {
			System.out.println("Fichier utilisateur de " + nom
					+ " non existant ! Création objet utilisateur avec propriétés vides.");
			this.enregistrer();
		}

	}

	
	public void enregistrer() {
		try {
			properties.storeToXML(new FileOutputStream(chemin), null);
		} catch (IOException e) {
			System.err.println("erreur d'enregistrement");
		}
	}

	
	public String getProperties(String key) {
		String valeur = properties.getProperty(key);
		if (valeur==null) {
			return "";
		}
		return valeur;
	}

	
	public void setProperties(String key, String valeur) {
		properties.setProperty(key, valeur);
	}

	
	public String getNom() {
		return nom;
	}
	
	
	public String getChemin() {
		return chemin;
	}

}
